#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <math.h>

#define BYTE unsigned char

/*
double do_exp_sqrt ( double d, void** import_table  )
{
	DFD dfd1 = 	(double (*) (double)) import_table[0],
		dfd2 = 	(double (*) (double)) import_table[1];

	return (*dfd2)((*dfd1)(d)); 
} 
*/
/* kompilierter Code */
BYTE code [] = {
	0x7c, 0x08, 0x02, 0xa6, 0xbf, 0xc1, 0xff, 0xf8, 0x90, 0x01, 
	0x00, 0x08, 0x94, 0x21, 0xff, 0xa0, 0x7c, 0x3e, 0x0b, 0x78, 
	0xd8, 0x3e, 0x00, 0x48, 0x90, 0xbe, 0x00, 0x80, 0x80, 0x5e, 
	0x00, 0x80, 0x80, 0x02, 0x00, 0x00, 0x90, 0x1e, 0x00, 0x3c, 
	0x80, 0x5e, 0x00, 0x80, 0x38, 0x42, 0x00, 0x04, 0x80, 0x02, 
	0x00, 0x00, 0x90, 0x1e, 0x00, 0x38, 0x80, 0x1e, 0x00, 0x3c, 
	0xc8, 0x3e, 0x00, 0x48, 0x7c, 0x0c, 0x03, 0x78, 0x7d, 0x89, 
	0x03, 0xa6, 0x4e, 0x80, 0x04, 0x21, 0xfc, 0x00, 0x08, 0x90, 
	0x80, 0x1e, 0x00, 0x38, 0xfc, 0x20, 0x00, 0x90, 0x7c, 0x0c, 
	0x03, 0x78, 0x7d, 0x89, 0x03, 0xa6, 0x4e, 0x80, 0x04, 0x21, 
	0xfc, 0x00, 0x08, 0x90, 0xfc, 0x20, 0x00, 0x90, 0x80, 0x21, 
	0x00, 0x00, 0x80, 0x01, 0x00, 0x08, 0x7c, 0x08, 0x03, 0xa6, 
	0xbb, 0xc1, 0xff, 0xf8, 0x4e, 0x80, 0x00, 0x20
};

/*	Funktionszeigerdeklaration für sqrt() & log10() */
typedef double (*DoubleFuncDouble) (double);

/*	Funktionszeigerdeklaration für kompilierten Code	*/
typedef double (*DoubleFuncDoubleVoidPP) (double, void**);

/*	leserlicheres Typecasting auf obigen Funktionszeiger 	*/
#define CAST_DFDVPP(pointer) (double (*)(double, void**)) (pointer)

int main ( int argc, char** argv )
{
	/*	Mini-Importtabelle	*/
	DoubleFuncDouble my_import_table [] = { log10, sqrt };
	
	/*	Platz für den Code	*/
	void* code_relocated = malloc ( sizeof ( code ) );
	
	/*	Funktionszeiger für impliziten Aufruf */
	DoubleFuncDoubleVoidPP func = CAST_DFDVPP(code_relocated);
	
	/*	wird 2.0 ;)	*/
	double result;
	
	/*	Codeblock auf den Heap kopieren, später entpacken usw....	*/
	memcpy(code_relocated, code, sizeof( code )); 
	
	/*	Spannung...	*/
	result = (*func)( 10000.0, (void**) my_import_table);

	printf("%f\n", result);

	/* damit keiner hinterher hineinschaut ;) */
	memset (code_relocated, 0, sizeof(code));
	
	free ( code_relocated );
	
	return 0;	
}