/*		
	myfunc.c
	
	Demofunktion für eingebetteten Code.
	
	Kompilieren und Assemblerdatei erzeugen mit:
		gcc -c -s myfunc.c
	
	Dann myfunc.s mit Texteditor öffnen und alle Assemblerdirektiven löschen. 
	
	Dann mit pasm:
		pasm -o myfunc.bin myfunc.s 
	
	Dann mit bin2inc:
		bin2inc myfunc.bin > myfunc.h
	
	Dann myfunc.h innerhald do_func.c includen oder einkopieren.
*/

typedef double (*DFD) (double);

double do_exp_sqrt ( double d, void** import_table  )
{

	DFD dfd1 = 	(double (*) (double)) import_table[0],
		dfd2 = 	(double (*) (double)) import_table[1];

	return (*dfd2)((*dfd1)(d)); 
}